org.gradle.jvm.tasks

## Class Jar

- java.lang.Object
- - org.gradle.api.internal.AbstractTask
  - - org.gradle.api.DefaultTask
    - - org.gradle.api.internal.ConventionTask
      - - org.gradle.api.tasks.AbstractCopyTask
        - - org.gradle.api.tasks.bundling.AbstractArchiveTask
          - - org.gradle.api.tasks.bundling.Zip
            - - org.gradle.jvm.tasks.Jar

- All Implemented Interfaces:
    Comparable<Task>, ContentFilterable, CopyProcessingSpec, CopySourceSpec, CopySpec, org.gradle.api.internal.DynamicObjectAware, org.gradle.api.internal.file.copy.CopySpecSource, org.gradle.api.internal.IConventionAware, org.gradle.api.internal.TaskInternal, ExtensionAware, Task, PatternFilterable, org.gradle.util.Configurable<Task>

      @Incubating
      public class Jar
      extends Zip

  Assembles a JAR archive.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.gradle.api.tasks.bundling.Zip

      `Zip.ZipCopyActionImpl`

    - ### Nested classes/interfaces inherited from interface org.gradle.api.Task

      `Task.Namer`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `DEFAULT_EXTENSION`

    - ### Fields inherited from class org.gradle.api.tasks.bundling.Zip

      `ZIP_EXTENSION`

    - ### Fields inherited from interface org.gradle.api.Task

      `TASK_ACTION, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Jar()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Manifest` | `getManifest()` Returns the manifest for this JAR archive.
    `CopySpec` | `getMetaInf()`
    `Jar` | `manifest(Closure<?> configureClosure)` Configures the manifest for this JAR archive.
    `CopySpec` | `metaInf(Closure<?> configureClosure)` Adds content to this JAR archive's META-INF directory.
    `void` | `setManifest(Manifest manifest)` Sets the manifest for this JAR archive.

    - ### Methods inherited from class org.gradle.api.tasks.bundling.Zip

      `createCopyAction, getCompressor, getEncoding, getEntryCompression, isZip64, setEncoding, setEntryCompression, setZip64`

    - ### Methods inherited from class org.gradle.api.tasks.bundling.AbstractArchiveTask

      `getAppendix, getArchiveName, getArchivePath, getBaseName, getClassifier, getDestinationDir, getExtension, getVersion, into, into, setAppendix, setArchiveName, setBaseName, setClassifier, setDestinationDir, setExtension, setVersion`

    - ### Methods inherited from class org.gradle.api.tasks.AbstractCopyTask

      `copy, createRootSpec, eachFile, eachFile, exclude, exclude, exclude, exclude, expand, filesMatching, filesNotMatching, filter, filter, filter, from, from, getDirMode, getDuplicatesStrategy, getExcludes, getFileLookup, getFileMode, getFileResolver, getFileSystem, getIncludeEmptyDirs, getIncludes, getInstantiator, getMainSpec, getRootSpec, getSource, include, include, include, include, isCaseSensitive, rename, rename, rename, setCaseSensitive, setDirMode, setDuplicatesStrategy, setExcludes, setFileMode, setIncludeEmptyDirs, setIncludes, with`

    - ### Methods inherited from class org.gradle.api.internal.ConventionTask

      `conventionMapping, conventionMapping, getConventionMapping`

    - ### Methods inherited from class org.gradle.api.internal.AbstractTask

      `addValidator, appendParallelSafeAction, compareTo, configure, deleteAllActions, dependsOn, dependsOnTaskDidWork, doFirst, doFirst, doLast, doLast, execute, finalizedBy, getActions, getAnt, getAsDynamicObject, getConvention, getDependsOn, getDescription, getDidWork, getEnabled, getExecuter, getExtensions, getFinalizedBy, getGroup, getImpliesSubProjects, getInputs, getLogger, getLogging, getMustRunAfter, getName, getOnlyIf, getOutputs, getPath, getProject, getServices, getShouldRunAfter, getStandardOutputCapture, getState, getTaskActions, getTaskDependencies, getTemporaryDir, getTemporaryDirFactory, getValidators, hasProperty, injectIntoNewInstance, isEnabled, isHasCustomActions, leftShift, mustRunAfter, onlyIf, onlyIf, prependParallelSafeAction, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setExecuter, setFinalizedBy, setGroup, setImpliesSubProjects, setMustRunAfter, setName, setOnlyIf, setOnlyIf, setProject, setProperty, setShouldRunAfter, shouldRunAfter, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_EXTENSION

          public static final String DEFAULT_EXTENSION

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Jar

          public Jar()

  - ### Method Detail

    - #### getManifest

          public Manifest getManifest()

      Returns the manifest for this JAR archive.
      Returns:
        The manifest

    - #### setManifest

          public void setManifest(Manifest manifest)

      Sets the manifest for this JAR archive.
      Parameters:
        `manifest` - The manifest. May be null.

    - #### manifest

          public Jar manifest(Closure<?> configureClosure)

      Configures the manifest for this JAR archive.

      The given closure is executed to configure the manifest. The `Manifest` is passed to the closure as its delegate.

      Parameters:
        `configureClosure` - The closure.
      Returns:
        This.

    - #### getMetaInf

          public CopySpec getMetaInf()

    - #### metaInf

          public CopySpec metaInf(Closure<?> configureClosure)

      Adds content to this JAR archive's META-INF directory.

      The given closure is executed to configure a `CopySpec`. The `CopySpec` is passed to the closure as its delegate.

      Parameters:
        `configureClosure` - The closure.
      Returns:
        The created `CopySpec`